azma/urls.py
from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from azma import views


admin.autodiscover()

urlpatterns = patterns('',
                       # Examples:
                       # url(r'^$', 'azma.views.home', name='home'),
                       # url(r'^blog/', include('blog.urls')),
                       url(r'^tinymce/', include('tinymce.urls')),
                       url(r'^cms/', include('azma_cms.urls')),
                       url(r'^blog/', include('elephantblog.urls')),
                       url(r'^comments/', include('django.contrib.comments.urls')),
                       url(r'^(?i)admin/', include(admin.site.urls)),
                       url(r'^(?i)about', views.about, name='about'),
                       url(r'^(?i)user/', include('user.urls')),
                       url(r'^(?i)profile', include('user_profile.urls', namespace='profile')),
                       url(r'^(?i)wage_meter/', include('wage_meter.urls', namespace='wages')),
                       url(r'^(?i)answer/', include('answer.urls', namespace='answer')),
                       url(r'^(?i)tutorial/', include('tutorial.urls', namespace='tutorial')),
                       url(r'^', include('exam.urls', namespace='exam')),
)

urlpatterns += staticfiles_urlpatterns()

tutorial/urls.py
from tutorial.views import *
from tutorial import views

__author__ = 'SOROOSH'

from django.conf.urls import patterns, url

urlpatterns = patterns('',
                       url(r'^$', TutorialView.as_view(), name="home"),
                       url(r'^cat/(?P<category_name>.*)$', TutorialWithCategoryView.as_view(), name="category"),
                       url(r'^tutorial_analyze/(?P<exam_tu_id>.*)', TutorialAnswerAnalyze.as_view(),
                           name='tutorial_exam_analyze'),
                       url(r'^tutorial_exam/(?P<tutorial_id>.*)', TutorialExamView.as_view(), name='tutorial_exam'),
                       url(r'^(?P<tutorial_name>.*)$', TutorialDetailView.as_view(), name="tutorial"),




)

tutorial/models.py
import os
import datetime

from django.contrib.auth.models import User
from django.db import models
from jdatetime import datetime as jalali_datetime
from tinymce.models import HTMLField
from django_enumfield import enum
from django.db.models import Sum, Count
from django.utils.encoding import force_text, force_str


class TutorialCategory(models.Model):
    class Meta:
        ordering = ['order']

    name = models.CharField(max_length=120, primary_key=True)
    local_name = models.CharField(max_length=120, )
    parent = models.ForeignKey("self", null=True, blank=True, related_name='sub_categories')
    description = HTMLField(default="Without description")
    img_address = models.CharField(default='image/techs/python.png', max_length=200)
    order = models.IntegerField(default=1)

    def __unicode__(self):
        return self.local_name


class Tutorial(models.Model):
    class Meta:
        ordering = ['registered_date']

    category = models.ForeignKey(TutorialCategory, related_name='tutorials')
    keyword = models.CharField(max_length=200)  # comma separated
    abstract = models.TextField()
    name = models.CharField(max_length=120, primary_key=True)
    local_name = models.CharField(max_length=150)
    author = models.ForeignKey(User)
    content = models.TextField()
    registered_date = models.DateTimeField()

    def get_persian_registered_date(self):
        return jalali_datetime.fromgregorian(datetime=self.registered_date).strftime('%Y/%m/%d')

    def __unicode__(self):
        return self.local_name


class TutorialExamState(enum.Enum):
    PENDING = 0
    PUBLISHED = 1
    FINISHED = 2
    labels = {
        PENDING: 'Pending',
        PUBLISHED: 'Published',
        FINISHED: 'Finished',
    }


class TutorialExam(models.Model):
    tutorial = models.OneToOneField(Tutorial, related_name='exam', primary_key=True)
    local_name = models.CharField(max_length=150)
    content = HTMLField()
    max_score = models.IntegerField(default=0)

    def score(self):
        score = self.question_set.aggregate(Sum('score'))['score__sum']
        if score is None:
            return 0
        else:
            return score

    def __unicode__(self):
        return self.local_name


def update_image_name(instance, filename):
    return os.path.join(
        os.path.join(os.path.normpath(force_text(datetime.datetime.now().strftime(force_str('question/images')))),
                     str(instance.id)) + '.png')


class TutorialQuestion(models.Model):
    text = models.CharField(max_length=500)
    exam = models.ForeignKey(TutorialExam, related_name="questions")
    score = models.IntegerField(default=1)
    code = models.TextField(null=True, blank=True)
    image = models.FileField(upload_to=update_image_name, null=True, blank=True)
    # according to this doc : https://docs.djangoproject.com/en/1.7/ref/models/fields/
    JAVA = "java"
    JS = "javascript"
    PHP = "PHP"
    LANGUAGES = (
        (JAVA, "Java"),
        (JS, "Javascript"),
        (PHP, "PHP")
    )
    code_type = models.CharField(max_length=15, choices=LANGUAGES, default=JAVA)

    def number_of_answers(self):
        return self.choice_set.filter(answer=True).aggregate(Count('answer'))['answer__count']

    def __str__(self):
        return str(self.id)


class TutorialChoice(models.Model):
    text = models.CharField(max_length=200)
    question = models.ForeignKey(TutorialQuestion, related_name="choice")
    answer = models.BooleanField(default=False)

    def __str__(self):
        return str(self.pk)


class TutorialExamAnswer(models.Model):
    user = models.ForeignKey(User)
    exam_tutorial = models.ForeignKey(TutorialExam)
    score = models.IntegerField(default=0)
    max_score = models.IntegerField(default=0)

    def __unicode__(self):
        return self.user.get_full_name() + " on exam: " + self.exam_tutorial.local_name


class TutorialExamAnswerHistory(models.Model):
    user = models.ForeignKey(User)
    exam_answers = models.ForeignKey(TutorialExam)

    def score(self):
        result = 0
        for answer in list(self.answers.all()):
            result += answer.catched_score()
        return result


class TutorialAnswer(models.Model):
    tutorial_question = models.ForeignKey(TutorialQuestion)
    tutorial_exam_answer = models.ForeignKey(TutorialExamAnswerHistory, related_name='answers')
    selected_answer_choices = models.ManyToManyField(TutorialChoice, related_name='ans+')

    def catched_score(self):
        if self.is_true():
            return self.tutorial_question.score
        else:
            return 0

    def is_true(self):
        if list(self.selected_answer_choices.all()) == list(self.tutorial_question.choice.filter(answer=True)):
            return True
        else:
            return False

tutorial/forms/TutorialForm.py
__author__ = 'mahdi'
from django.forms.models import ModelForm
from tutorial.models import Tutorial
from django.utils.text import ugettext_lazy as _
from CKeditor.widgets import ArticleWidget


class TutorialForm(ModelForm):



    class Meta:
        model = Tutorial
        fields = ("category", "keyword", "abstract", "name", "local_name", "author", "content", "registered_date")
        labels = {
            "Category": _("Tutorial Category"),
            "keyword": _("Tutorial Keywords"),
            "abstract": _("Tutorial Abstract"),
            "name": _("Tutorial Name"),
            "local_name": _("Tutorial Local Name"),
            "content": _("Tutorial Content"),
            "author": _("Tutorial Author"),
            "registered_date": _("Tutorial Submit Date"),
        }
        help_texts = {
            "Category": _("Which Category this tutorial belongs to ?"),
            "keyword": _("Describe this tutorial contents with keywords , no more than 75 characters"),
            "abstract": _("a Breif of this tutorial"),
            "name": _("a name which will be used for accessing this tutorial via url"),
            "local_name": _("a friendly name for identifing the tutorial"),
            "content": _("tutorial content "),
            "author": _("the author who writes this tutorial , perhaps you"),
            "registered_date": _("tutorial publish date"),
        }

        widgets = {
            # "Category": ,
            #"keyword": ,
            "abstract": ArticleWidget(),
            #"name": ,
            #"local_name":,
            "content": ArticleWidget(),
            #"author": ,
            #"registered_date": ,
        }

        # error_messages = {
        # "Category": {
        #
        #     },
        #     "keyword": {
        #
        #     },
        #     "abstract": {
        #
        #     },
        #     "name": {
        #
        #     },
        #     "local_name": {
        #
        #     },
        #     "content": {
        #
        #     },
        #     "author": {
        #
        #     },
        #     "registered_date": {
        #
        #     },
        # }
        #

tutorial/views.py
from django.template import loader
from django.template.context import RequestContext
from django.views.generic import View
from django.http.response import HttpResponse
from django.conf import settings

from tutorial.models import TutorialCategory, Tutorial, TutorialExam, TutorialExamAnswer, TutorialExamAnswerHistory, \
    TutorialAnswer


class TutorialView(View):
    def get(self, request):
        categories = TutorialCategory.objects.filter(parent_id=None)
        latest_tutorials = Tutorial.objects.all().order_by('-registered_date').all()[:5]

        template = loader.get_template('tutorial_page.html')

        context = RequestContext(request, {'latest_tutorials': latest_tutorials, 't_categories': categories})
        return HttpResponse(template.render(context))


class TutorialWithCategoryView(View):
    def get(self, request, category_name):
        categories = TutorialCategory.objects.filter(parent_id=None)
        t_category = TutorialCategory.objects.get(name=category_name.upper())
        category = t_category
        latest_tutorials = Tutorial.objects.all().order_by('-registered_date').all()[:5]
        while category.parent is not None:
            category = category.parent
        template = loader.get_template('category_detail.html')

        context = RequestContext(request,
                                 {'latest_tutorials': latest_tutorials, 'category': category, 't_category': t_category,
                                  't_categories': categories})
        return HttpResponse(template.render(context))


class TutorialDetailView(View):
    def get(self, request, tutorial_name):

        try:
            tutorial_exam = TutorialExam.objects.get(pk=tutorial_name)
        except TutorialExam.DoesNotExist:
            tutorial_exam = None

        categories = TutorialCategory.objects.filter(parent_id=None)
        tutorial = Tutorial.objects.get(name=tutorial_name.upper())
        latest_tutorials = Tutorial.objects.all().order_by('-registered_date').all()[:5]
        path = settings.SERVER_BASE_ADDRESS
        category = tutorial.category
        while category.parent is not None:
            category = category.parent
        template = loader.get_template('tutorial_detail.html')
        context = RequestContext(request,
                                 {'latest_tutorials': latest_tutorials, 'category': category, 'tutorial': tutorial,
                                  't_categories': categories, 'path': path, 'exam': tutorial_exam, })
        return HttpResponse(template.render(context))


class TutorialAnswerAnalyze(View):
    def post(self, request, exam_tu_id):
        tutorial_exam = TutorialExam.objects.get(pk=exam_tu_id)
        exam_answer, is_new = TutorialExamAnswer.objects.get_or_create(user_id=request.user.id,
                                                                       exam_tutorial_id=exam_tu_id)
        exam_answer_history = TutorialExamAnswerHistory()
        exam_answer_history.user_id = request.user.id
        exam_answer_history.exam_answers = tutorial_exam
        exam_answer_history.save()
        for q in tutorial_exam.questions.all():
            answer = TutorialAnswer()
            answer.tutorial_question = q
            answer.tutorial_exam_answer = exam_answer_history
            answer.save()

            if str(q.id) in request.POST.keys():
                for a in request.POST.getlist(str(q.id)):
                    answer.selected_answer_choices.add(a)

            else:
                answer.selected_answer_choices.add(-1)

        total_score = 0
        for i in tutorial_exam.questions.all():
            total_score += i.score
        exam_answer.max_score = total_score
        exam_answer.save()

        if exam_answer_history.score() > exam_answer.score:
            exam_answer.score = exam_answer_history.score()
            exam_answer.save()
        template = loader.get_template('quiz_answer.html')
        context = RequestContext(request, {'tu_answer': exam_answer_history, })
        return HttpResponse(template.render(context))


class TutorialExamView(View):
    def get(self, request, tutorial_id):
        tutorial_exam = TutorialExam.objects.get(pk=tutorial_id)
        try:
            exam_answer = TutorialExamAnswer.objects.get(user_id=request.user.id, exam_tutorial_id=tutorial_id)
        except Exception as e:
            exam_answer = None

        total_score = 0
        for i in tutorial_exam.questions.all():
            total_score += i.score
        tutorial_exam.max_score = total_score
        tutorial_exam.save()
        template = loader.get_template('tutorial_exam.html')
        context = RequestContext(request, {'exam': tutorial_exam, 'answer': exam_answer, })
        return HttpResponse(template.render(context))

tutorial/templates/_category_list.html
    {% for c in categories %}
        <div >

            <a style="padding-right: {{ base }}5px; font-weight: 400;" href="{% url 'tutorial:category' c.name %}">
                {{ c.local_name }}

            </a>
        </div>
        {% if not no_category %}
            {% with base=1 categories=c.sub_categories.all template_name="_category_list.html" %}
                {% include template_name %}
            {% endwith %}
        {% endif %}
        {% if not  no_detail %}
            <div class="category" style="color:#ffffff;">
                {% for t in c.tutorials.all %}
                    <div   style=" padding-bottom: 0px; margin: 0px"
                         class="{% if t.name == tutorial.name %}active{% endif %}">
                        <a style="color:#ffffff;" href="{% url 'tutorial:tutorial' t.name %}">
                            {{ t.local_name }}
                        </a>
                    </div>
                {% endfor %}
            </div>
        {% endif %}
    {% endfor %}

tutorial/templates/_category_list_nav.html
    {% for c in categories %}
<li >
            <a style="font-weight: bold;" href="{% url 'tutorial:category' c.name %}">
                {{ c.local_name }}

            </a>
</li>

    {% endfor %}

tutorial/templates/category_detail.html
{% extends 'base.html' %}
{% block keywords %}{% for c in t_category.sub_categories.all %}آموزش
    {{ c.local_name }}{% if not forloop.last %},{% endif %}{% endfor %}{% endblock %}
{% load staticfiles %}
{% block title %}
    {{ category.local_name }}
{% endblock %}

{% block no_container_content %}
    <body background="/static/image/Blue-and-Purple-Blur-Background.jpg" class="" style=" background-size: 300%">
    <div style="overflow-x: hidden">
        <nav class="navbar1 navbar-default">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle1" data-toggle="collapse"
                        data-target="#navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>

            </div>
            <div class="row collapse navbar-collapse1" id="navbar-collapse">
                <ul class="nav-top navbar-nav pull-right">

                    {% include '_category_list_nav.html' with categories=t_categories no_detail='True' no_category='True' %}
                </ul>
            </div>
        </nav>
    </div>


    <div class="col-xs-3 sidebar  pull-right" style="margin-top: 0">
        <ul class="nav nav-sidebar">
            <li>
                <div class="panel-group" id="accordion">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <h4 class="panel-title">
                                <a data-parent="#accordion" style="font-weight: bold">
                                    بخش آموزشی {{ category.local_name }}
                                </a>
                            </h4>
                        </div>
                        <div id="collapseOne" class="panel-collapse collapse in">
                            <div class="panel-body">
                                {% include '_category_list.html' with categories=category.sub_categories.all %}

                            </div>
                        </div>
                    </div>

                </div>
        </ul>
    </div>

    <div class="col-xs-8" style="  background-color:#ffffff; border: solid 2px #CCCCCC;padding: 10px;">
        <div class="well1">
            <div class="row">
                <div class="col-xs-9">
                    <h1 style="font-family:Yekan">
                        {{ t_category.local_name }}
                    </h1>
                    {{ t_category.description | safe }}

                </div>
                <div class="col-xs-2 pull-left">
                    <img class="img-thumbnail img-rounded" style="border: solid #eeeeee" src="{% static t_category.img_address %}"/>
                </div>
            </div>
        </div>

        {% for c in t_category.sub_categories.all %}
            <div class="well1">
                <div class="row">
                    <div class="col-xs-11">
                        <h4 style="font-weight: bold;"><a
                                href="{% url 'tutorial:category' c.name %}"> {{ c.local_name }}</a></h4>
                        <hr/>
                        {{ c.description | safe }}
                    </div>
                    <div class="col-xs-1 pull-left" style="text-align: left;">
                        <img style="width:64px;border: solid #eeeeee;   " class="img-responsive img-thumbnail img-rounded "
                             src="{% static c.img_address %}"/>
                    </div>
                </div>
            </div>
        {% endfor %}

        {% for t in t_category.tutorials.all %}
            <div class="well1">
                <div class="row">
                    <div class="col-xs-11">
                        <h4 style="font-weight: bold;"><a
                                href="{% url 'tutorial:tutorial' t.name %}"> {{ t.local_name }}</a></h4>
                        <hr/>
                        {{ t.abstract | safe }}
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
    </div>
    </body>

{% endblock %}

tutorial/templates/tutorial_detail.html
{% extends 'base.html' %}
{% load comments %}
{% load staticfiles %}
{% block keywords %}{{ tutorial.keyword }}{% endblock %}
{% block title %}
    {{ tutorial.local_name }}
{% endblock %}

{% block no_container_content %}


    <body style="background-image: url('{% static 'image/tree_bark.png' %}');">
    <div style="overflow-x: hidden">
        <nav class="navbar1 navbar-default">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle1" data-toggle="collapse"
                        data-target="#navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
            </div>
            <div class="row collapse navbar-collapse1" id="navbar-collapse">
                <ul class="nav-top navbar-nav pull-right ">

                    {% include '_category_list_nav.html' with categories=t_categories no_detail='True' no_category='True' %}
                </ul>
            </div>
        </nav>
    </div>


    <div class="col-xs-3 sidebar pull-right" style="margin-top: 0px">
        <ul class="nav nav-sidebar">
            <li>
                <div class="panel-group" id="accordion">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <h3 class="panel-title">
                                <a data-parent="#accordion" style="font-weight: bold">
                                    بخش آموزشی {{ category.local_name }}
                                </a>
                            </h3>
                        </div>
                        <div id="collapseOne" class="panel-collapse collapse in">
                            <div class="panel-body">

                                {% include '_category_list.html' with categories=category.sub_categories.all %}
                            </div>
                        </div>
                    </div>

                </div>
        </ul>
    </div>

    <div class="col-xs-8"
         style="  background-color:#ffffff; border: solid 1px #888;padding: 10px; ">

        <div class="well1" style="margin-bottom: 5px">


            <div class="row">
                <div class="col-xs-8">

                    <h1 style="font-family:Yekan">


                        {{ tutorial.local_name }}


                    </h1>

                    <div class="row">
                        <div class="col-xs-2">
                            <img class="img-responsive img-thumbnail "
                                 src="http://www.gravatar.com/avatar/{{ tutorial.author.profile.email_md5 }}"/>
                        </div>
                        <div class="col-xs-8">
                            <div>
                                نویسنده: &nbsp;
                                {{ tutorial.author.get_full_name }}
                            </div>
                            <div>
                                در تاریخ: &nbsp;
                                {{ tutorial.get_persian_registered_date }}
                            </div>
                        </div>
                    </div>


                </div>


                <div class="col-xs-2 pull-left" style="text-align: left;">


                    <img class="img-responsive img-thumbnail img-rounded" style="border: solid #eeeeee;"
                         src="{% static tutorial.category.img_address %}"/>

                </div>


            </div>
            <div class="row" style="padding: 5px;">
                <div class=" pull-left img-responsive" style=" padding-left: 15px;">
                    <a href="https://www.facebook.com/sharer.php?u={{ path }}{{ request.get_full_path }}" target="_blank">
                        <img class="img-responsive" src="/static/image/facebook_button.png">
                    </a>
                </div>
            </div>
        </div>
        <div class="tutorial-content" style="padding: 30px;">
            {{ tutorial.content | safe }}
        </div>


        {% if user.is_authenticated and exam != None %}
            <div class="row" style="margin: 20px;">
                <a class="btn btn-gentel col-xs-12" href="{% url 'tutorial:tutorial_exam' tutorial.name %}">شرکت در خودآزمایی</a>
            </div>
        {% elif  user.is_authenticated and exam == None %}
            <div class="row" style="margin: 20px;">
                <div class="btn btn-gentel col-xs-12">متاسفانه این بخش آزمون ندارد</div>

            </div>
        {% else %}
            <div style=" padding-bottom: 34px; position: inherit;">
                <a class="btn btn-gentel col-xs-12" href="{% url 'login' %}">
                    با ورود به سیستم شما میتوانید در خودآزمایی این آموزش شرکت کنید
                </a>
            </div>
        {% endif %}

        <div style="padding-top: 2px;">
            <div class="well1" style="border: solid 1px #bbbbbb;">
                {% get_comment_count for tutorial as comment_count %}
                <div class="well1" style="border: solid 1px #bbbbbb;padding: 5px; padding-right: 20px;"> تا به حال {{ comment_count }} نظر برای این
                    آموزش داده شده است.
                </div>
                <div class="well1">
                    {% render_comment_list for tutorial %}
                </div>
                {#                <div class="well">#}
                {#                    {% render_comment_form for tutorial %}#}
                {#                </div>#}
                <div class="well1">
                    {% if user.is_authenticated %}
                        {% get_comment_form for tutorial as form %}
                        <form action="{% comment_form_target %}" method="POST">
                            {% csrf_token %}
                            <div class="row">
                                <div class="col-xs-2">
                                    کامنت
                                </div>
                                <div class="col-xs-9">
                                    <textarea class="form-control" name="comment"
                                              style="margin-bottom: 15px;"></textarea>
                                    {#                                    {{ form.comment }}#}
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-xs-2">
                                    چیزی ننویسید
                                </div>
                                <div class="col-xs-3">
                                    <input type="text" class="form-control" name="honeypot"
                                           style="margin-bottom: 15px;"></textarea>
                                </div>
                            </div>

                            {{ form.content_type }}
                            {{ form.object_pk }}
                            {{ form.timestamp }}
                            {{ form.security_hash }}
                            <input type="hidden" name="next" value="{% url 'tutorial:tutorial' tutorial.name %}"/>
                            <input class="btn btn-lg btn-success" style="width: 100%;" type="submit" value="ثبت"
                                   id="id_submit"/>
                        </form>
                    {% else %}
                        <p>برای کامنت لطفا
                            <a href="{% url 'login' %}">وارد</a>
                            شوید
                        </p>

                    {% endif %}

                </div>
            </div>
        </div>

    </div>
    </body>
{% endblock %}

tutorial/templates/tutorial_exam.html
{% extends 'base.html' %}
{% load staticfiles %}
{% block title %}آزمون {{ exam }}{% endblock %}

{% block css %}
    <link href="{% static "UI/checkbox/input.checkbox.css" %}" rel="stylesheet">
    <link href="{% static "UI/radiobutton/input.radiobutton.css" %}" rel="stylesheet">
    <link href="{% static "UI/img/img.css" %}" rel="stylesheet">
    <link href="{% static 'UI/codeHolder/codeHolder.css' %}" rel="stylesheet">

{% endblock %}
{% block content %}
    <div class="row">
        <div class="col-xs-9">
            <h1>حالا با این چندتا سوال خودتو محک بزن</h1>
        </div>
        <div class="col-xs-3">
            <h3 class="pull-left">
                <a href="{% url 'tutorial:tutorial' exam.name %}">
                    بازگشت به آموزش
                </a>
            </h3>
        </div>

    </div>
    <hr style="padding-bottom: 20px;">
    {% if answer.score != exam.max_score %}

        <form method="post" action="{% url 'tutorial:tutorial_exam_analyze' exam.tutorial.name %}">

            {% if answer.score != exam.max_score %}
                {% csrf_token %}
            {% endif %}

            <div class="row">
                <div class="col-xs-12 col-md-12 col-lg-9  table-bordered"
                     style="padding-bottom: 20px;padding-top: 20px;float:left;font-size: 17px; background-color: rgba(0,0,0,0.4)">
                    {% for q in exam.questions.all %}
                        <div class="quiz" style="margin-bottom: 25px;box-shadow: 5px 5px #f2dede; border-radius: 5px;">
                            <div class="row">
                                <div class="col-lg-8" style="margin-bottom: 10px;">
                                    <li>  {{ q.text | safe }} </li>
                                </div>
                                <div class="col-lg-4" style="margin-bottom: 10px;">
                                    {% if q.image %}
                                        <img class="img-thumbnail exam-img" src="{{ q.image.url }}"/>
                                    {% endif %}
                                </div>
                            </div>
                            {% if q.code %}
                                <div class="row">
                                    <div class="col-lg-12">
                                        <div class="CodeSheet src-{{ q.code_type }}">
                                            <pre>{{ q.code }}</pre>
                                        </div>
                                    </div>
                                </div>
                            {% endif %}
                            <div class="row">
                                {% for ch in q.choice.all %}
                                    {% if ch.id != -1 %}
                                        <div class="col-lg-12 answer-option" style="padding-bottom: 10px;">
                                            <div class='checkbox'>
                                                <label for="opt{{ ch.id }}">
                                                    <input id="opt{{ ch.id }}"
                                                           value="{{ ch.id }}"
                                                           name="{{ q.id }}"
                                                           type={% if q.number_of_answers > 1 %}'checkbox' {% else %}
                                                               'radio'{% endif %}/>

                                                    {{ ch.text | safe }}

                                                </label>

                                            </div>
                                        </div>

                                    {% endif %}
                                {% endfor %}
                            </div>
                        </div>
                    {% endfor %}

                    <button type="submit" class="btn btn-success btn-lg center-block">
                        ثبت
                    </button>
                </div>
            </div>
        </form>
    {% else %}
        <h3 style="text-align: center"> {{ user.username }} گرامی شما این آزمون را گذرانده اید.</h3>
    {% endif %}

{% endblock %}